.head 0 +  Application Description: EMGETSETSEL - Sample Application
Original EM_SETSEL sample by Ron Jacobs
Gupta Corporation Technical Support
---------------------------------------------------------------------------------------
This application demonstrates how to select text in a data field 
using the EM_SETSEL message defined by Windows.

Also demonstrates EM_GETSEL to get the start/end values for any
selected text and assign 2nd multiline field with the selected text.

Sample & EM_GETSEL code provided by
    Jeff Luther/PC Design
    pcdesign@pulpcards.com
    http://www.pulpcards.com/centura/

.head 1 -  Outline Version - 4.0.27
.head 1 +  Design-time Settings
.data VIEWINFO
0000: 6F00000001000000 FFFF01000D004347 5458566965775374 6174650400010000
0020: 0000000000700000 002C000000020000 0003000000FFFFFF FFFFFFFFFFFCFFFF
0040: FFE9FFFFFF000000 0000000000A00300 0048010000010000 0001000000010000
0060: 000F4170706C6963 6174696F6E497465 6D00000000
.enddata
.head 2 -  Outline Window State: Normal
.head 2 +  Outline Window Location and Size
.data VIEWINFO
0000: 6600010000001B00 0200000000002602 CA01F41A4E0D0500 1D00FFFF4D61696E
0020: 00
.enddata
.data VIEWSIZE
0000: 2100
.enddata
.head 3 -  Left: 0.025"
.head 3 -  Top:    0.042"
.head 3 -  Width:  7.9"
.head 3 -  Height: 2.167"
.head 2 +  Options Box Location
.head 3 -  Visible? Yes
.head 3 -  Left: 3.5"
.head 3 -  Top:    2.583"
.head 3 -  Width:  3.738"
.head 3 -  Height: 2.177"
.head 2 +  Class Editor Location
.head 3 -  Visible? No
.head 3 -  Left: Default
.head 3 -  Top:    Default
.head 3 -  Width:  Default
.head 3 -  Height: Default
.head 2 +  Tool Palette Location
.head 3 -  Visible? No
.head 3 -  Left: 7.475"
.head 3 -  Top:    1.979"
.head 2 -  Fully Qualified External References? No
.head 2 -  Reject Multiple Window Instances? No
.head 2 -  Enable Runtime Checks Of External References? No
.head 2 -  Use Release 4.0 Scope Rules? Yes
.head 2 +  ! Outline Browser Location
.head 3 -   Visible? No
.head 3 -   Left:   Default
.head 3 -   Top:    Default
.head 3 -   Width:  Default
.head 3 -   Height: Default
.head 1 -  Libraries
.head 1 +  Global Declarations
.head 2 +  Window Defaults
.head 3 +  Tool Bar
.head 4 -  Display Style? Standard
.head 4 -  Font Name: System Default
.head 4 -  Font Size: System Default
.head 4 -  Font Enhancement: System Default
.head 4 -  Text Color: System Default
.head 4 -  Background Color: System Default
.head 3 +  Form Window
.head 4 -  Display Style? Standard
.head 4 -  Font Name: arial
.head 4 -  Font Size: 8
.head 4 -  Font Enhancement: System Default
.head 4 -  Text Color: System Default
.head 4 -  Background Color: System Default
.head 3 +  Dialog Box
.head 4 -  Display Style? Standard
.head 4 -  Font Name: System Default
.head 4 -  Font Size: System Default
.head 4 -  Font Enhancement: System Default
.head 4 -  Text Color: System Default
.head 4 -  Background Color: System Default
.head 3 +  Top Level Table Window
.head 4 -  Font Name: System Default
.head 4 -  Font Size: System Default
.head 4 -  Font Enhancement: System Default
.head 4 -  Text Color: System Default
.head 4 -  Background Color: System Default
.head 3 +  Data Field
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 4 -  Text Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  Multiline Field
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 4 -  Text Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  Spin Field
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 4 -  Text Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  Background Text
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 4 -  Text Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  Pushbutton
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 3 +  Radio Button
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 4 -  Text Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  Check Box
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 4 -  Text Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  Option Button
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 3 +  Group Box
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 4 -  Text Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  Child Table Window
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 4 -  Text Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  List Box
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 4 -  Text Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  Combo Box
.head 4 -  Font Name: Use Parent
.head 4 -  Font Size: Use Parent
.head 4 -  Font Enhancement: Use Parent
.head 4 -  Text Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  Line
.head 4 -  Line Color: Use Parent
.head 3 +  Frame
.head 4 -  Border Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 3 +  Picture
.head 4 -  Border Color: Use Parent
.head 4 -  Background Color: Use Parent
.head 2 +  Formats
.head 3 -  Number: 0%
.head 3 -  Number: #0
.head 3 -  Number: ###000
.head 3 -  Number: ###000;###000
.head 3 -  Date/Time: hh:mm:ss AMPM
.head 3 -  Date/Time: M/d/yy
.head 3 -  Date/Time: MM-dd-yy
.head 3 -  Date/Time: dd-MMM-yyyy
.head 3 -  Date/Time: MMM d, yyyy
.head 3 -  Date/Time: MMM d, yyyy hh:mm AMPM
.head 3 -  Date/Time: MMMM d, yyyy hh:mm AMPM
.head 2 -  External Functions
.head 2 +  Constants
.data CCDATA
0000: 3000000000000000 0000000000000000 00000000
.enddata
.data CCSIZE
0000: 1400
.enddata
.head 3 -  System
.head 3 +  User
.head 4 -  ! These constants are defined by Windows, but must be declared here
.head 4 -  Number: WM_USER		= 0x0400
.head 4 -  Number: EM_GETSEL	= WM_USER + 0
.head 4 -  Number: EM_SETSEL	= WM_USER + 1
.head 2 -  Resources
.head 2 -  Variables
.head 2 -  Named Menus
.head 2 -  Internal Functions
.head 2 -  Class Definitions
.head 2 +  Default Classes
.head 3 -  MDI Window:
.head 3 -  Form Window:
.head 3 -  Dialog Box:
.head 3 -  Table Window:
.head 3 -  Quest Window:
.head 3 -  Data Field:
.head 3 -  Spin Field:
.head 3 -  Multiline Field:
.head 3 -  Pushbutton:
.head 3 -  Radio Button:
.head 3 -  Check Box:
.head 3 -  Option Button:
.head 3 -  Child Table:
.head 3 -  Quest Child Window:
.head 3 -  List Box:
.head 3 -  Combo Box:
.head 3 -  Picture:
.head 3 -  Vertical Scroll Bar:
.head 3 -  Horizontal Scroll Bar:
.head 3 -  Column:
.head 3 -  Background Text:
.head 3 -  Group Box:
.head 3 -  Line:
.head 3 -  Frame:
.head 3 -  Custom Control:
.head 3 -  ActiveX:
.head 2 -  Application Actions
.head 1 +  Form Window: frmSetSel
.head 2 -  Class:
.head 2 -  Property Template:
.head 2 -  Class DLL Name:
.head 2 -  Title: EM_SETSEL example
.head 2 -  Icon File:
.head 2 -  Accesories Enabled? No
.head 2 -  Visible? Yes
.head 2 -  Display Settings
.head 3 -  Display Style? Etched
.head 3 -  Visible at Design time? Yes
.head 3 -  Automatically Created at Runtime? Yes
.head 3 -  Initial State: Normal
.head 3 -  Maximizable? Yes
.head 3 -  Minimizable? Yes
.head 3 -  System Menu? Yes
.head 3 -  Resizable? Yes
.head 3 -  Window Location and Size
.head 4 -  Left: 5.55"
.head 4 -  Top:    6.052"
.head 4 -  Width:  4.45"
.head 4 -  Width Editable? Yes
.head 4 -  Height: 4.31"
.head 4 -  Height Editable? Yes
.head 3 -  Form Size
.head 4 -  Width:  Default
.head 4 -  Height: Default
.head 4 -  Number of Pages: Dynamic
.head 3 -  Font Name: Default
.head 3 -  Font Size: Default
.head 3 -  Font Enhancement: Default
.head 3 -  Text Color: Default
.head 3 -  Background Color: Default
.head 2 -  Description:
.head 2 -  Named Menus
.head 2 +  Menu
.head 3 +  Menu Item: &GetSelectedText!
.head 4 -  Resource Id: 54603
.head 4 -  Keyboard Accelerator: (none)
.head 4 -  Status Text:
.head 4 +  Menu Settings
.head 5 -  Enabled when:
.head 5 -  Checked when:
.head 4 +  Menu Actions
.head 5 -  Set dfnStart = -1
.head 5 -  Set dfnEnd = -1
.head 5 -  Set mlsSelectedText = ''
.head 5 -  Call GetSelectedText( mlsData, dfnStart, dfnEnd, mlsSelectedText )
.head 4 -  Menu Item Name:
.head 3 +  Menu Item: &SelectText!
.head 4 -  Resource Id: 27026
.head 4 -  Keyboard Accelerator: (none)
.head 4 -  Status Text:
.head 4 +  Menu Settings
.head 5 -  Enabled when:
.head 5 -  Checked when:
.head 4 +  Menu Actions
.head 5 -  Set mlsSelectedText = ''
.head 5 +  If SalIsValidInteger( dfnStart ) AND SalIsValidInteger( dfnEnd )
.head 6 -  Call SelectText( mlsData, dfnStart, dfnEnd )
.head 4 -  Menu Item Name:
.head 3 +  Menu Item: &DeelectAllText!
.head 4 -  Resource Id: 54608
.head 4 -  Keyboard Accelerator: (none)
.head 4 -  Status Text:
.head 4 +  Menu Settings
.head 5 -  Enabled when:
.head 5 -  Checked when:
.head 4 +  Menu Actions
.head 5 -  Set dfnStart = 0
.head 5 -  Set dfnEnd = 0
.head 5 -  Set mlsSelectedText = ''
.head 5 -  Call SelectText( mlsData, dfnStart, dfnEnd )
.head 4 -  Menu Item Name:
.head 2 +  Tool Bar
.head 3 -  Display Settings
.head 4 -  Display Style? Default
.head 4 -  Location? Top
.head 4 -  Visible? Yes
.head 4 -  Size: Default
.head 4 -  Size Editable? Yes
.head 4 -  Font Name: Default
.head 4 -  Font Size: Default
.head 4 -  Font Enhancement: Default
.head 4 -  Text Color: Default
.head 4 -  Background Color: Default
.head 3 -  Contents
.head 2 +  Contents
.head 3 -  Background Text: Start:
.head 4 -  Resource Id: 54604
.head 4 -  Class Child Ref Key: 0
.head 4 -  Class ChildKey: 0
.head 4 -  Class:
.head 4 -  Window Location and Size
.head 5 -  Left: 0.383"
.head 5 -  Top:    0.369"
.head 5 -  Width:  0.6"
.head 5 -  Width Editable? Yes
.head 5 -  Height: 0.167"
.head 5 -  Height Editable? Yes
.head 4 -  Visible? Yes
.head 4 -  Justify: Right
.head 4 -  Font Name: Default
.head 4 -  Font Size: Default
.head 4 -  Font Enhancement: Default
.head 4 -  Text Color: Default
.head 4 -  Background Color: Default
.head 3 -  Group Box: Select Paramters
.head 4 -  Resource Id: 54605
.head 4 -  Class Child Ref Key: 0
.head 4 -  Class ChildKey: 0
.head 4 -  Class:
.head 4 -  Window Location and Size
.head 5 -  Left: 0.183"
.head 5 -  Top:    0.071"
.head 5 -  Width:  3.7"
.head 5 -  Width Editable? Yes
.head 5 -  Height: 0.583"
.head 5 -  Height Editable? Yes
.head 4 -  Visible? Yes
.head 4 -  Font Name: Default
.head 4 -  Font Size: Default
.head 4 -  Font Enhancement: Default
.head 4 -  Text Color: Default
.head 4 -  Background Color: Default
.head 3 -  Background Text: End:
.head 4 -  Resource Id: 54606
.head 4 -  Class Child Ref Key: 0
.head 4 -  Class ChildKey: 0
.head 4 -  Class:
.head 4 -  Window Location and Size
.head 5 -  Left: 1.983"
.head 5 -  Top:    0.357"
.head 5 -  Width:  0.7"
.head 5 -  Width Editable? Yes
.head 5 -  Height: 0.167"
.head 5 -  Height Editable? Yes
.head 4 -  Visible? Yes
.head 4 -  Justify: Right
.head 4 -  Font Name: Default
.head 4 -  Font Size: Default
.head 4 -  Font Enhancement: Default
.head 4 -  Text Color: Default
.head 4 -  Background Color: Default
.head 3 +  Data Field: dfnStart
.head 4 -  Class Child Ref Key: 0
.head 4 -  Class ChildKey: 0
.head 4 -  Class:
.head 4 -  Property Template:
.head 4 -  Class DLL Name:
.head 4 -  Data
.head 5 -  Maximum Data Length: Default
.head 5 -  Data Type: Number
.head 5 -  Editable? Yes
.head 4 -  Display Settings
.head 5 -  Window Location and Size
.head 6 -  Left: 1.083"
.head 6 -  Top:    0.321"
.head 6 -  Width:  0.6"
.head 6 -  Width Editable? Yes
.head 6 -  Height: 0.25"
.head 6 -  Height Editable? Yes
.head 5 -  Visible? Yes
.head 5 -  Border? Yes
.head 5 -  Justify: Left
.head 5 -  Format: Unformatted
.head 5 -  Country: Default
.head 5 -  Font Name: Default
.head 5 -  Font Size: Default
.head 5 -  Font Enhancement: Default
.head 5 -  Text Color: Default
.head 5 -  Background Color: Default
.head 5 -  Input Mask: Unformatted
.head 4 +  Message Actions
.head 5 +  On SAM_Create
.head 6 -  Set dfnStart = 3
.head 3 +  Data Field: dfnEnd
.head 4 -  Class Child Ref Key: 0
.head 4 -  Class ChildKey: 0
.head 4 -  Class:
.head 4 -  Property Template:
.head 4 -  Class DLL Name:
.head 4 -  Data
.head 5 -  Maximum Data Length: Default
.head 5 -  Data Type: Number
.head 5 -  Editable? Yes
.head 4 -  Display Settings
.head 5 -  Window Location and Size
.head 6 -  Left: 2.783"
.head 6 -  Top:    0.321"
.head 6 -  Width:  0.6"
.head 6 -  Width Editable? Yes
.head 6 -  Height: 0.25"
.head 6 -  Height Editable? Yes
.head 5 -  Visible? Yes
.head 5 -  Border? Yes
.head 5 -  Justify: Left
.head 5 -  Format: Unformatted
.head 5 -  Country: Default
.head 5 -  Font Name: Default
.head 5 -  Font Size: Default
.head 5 -  Font Enhancement: Default
.head 5 -  Text Color: Default
.head 5 -  Background Color: Default
.head 5 -  Input Mask: Unformatted
.head 4 +  Message Actions
.head 5 +  On SAM_Create
.head 6 -  Set dfnEnd = 12
.head 3 -  Background Text: Data:
.head 4 -  Resource Id: 54607
.head 4 -  Class Child Ref Key: 0
.head 4 -  Class ChildKey: 0
.head 4 -  Class:
.head 4 -  Window Location and Size
.head 5 -  Left: 0.183"
.head 5 -  Top:    0.69"
.head 5 -  Width:  0.433"
.head 5 -  Width Editable? Yes
.head 5 -  Height: 0.167"
.head 5 -  Height Editable? Yes
.head 4 -  Visible? Yes
.head 4 -  Justify: Right
.head 4 -  Font Name: Default
.head 4 -  Font Size: Default
.head 4 -  Font Enhancement: Default
.head 4 -  Text Color: Default
.head 4 -  Background Color: Default
.head 3 +  Multiline Field: mlsData
.head 4 -  Class Child Ref Key: 0
.head 4 -  Class ChildKey: 0
.head 4 -  Class:
.head 4 -  Property Template:
.head 4 -  Class DLL Name:
.head 4 -  Data
.head 5 -  Maximum Data Length: Default
.head 5 -  String Type: String
.head 5 -  Editable? Yes
.head 4 -  Display Settings
.head 5 -  Border? Yes
.head 5 -  Word Wrap? Yes
.head 5 -  Vertical Scroll? Yes
.head 5 -  Window Location and Size
.head 6 -  Left: 0.083"
.head 6 -  Top:    0.905"
.head 6 -  Width:  3.9"
.head 6 -  Width Editable? Yes
.head 6 -  Height: 1.5"
.head 6 -  Height Editable? Yes
.head 5 -  Visible? Yes
.head 5 -  Font Name: Default
.head 5 -  Font Size: Default
.head 5 -  Font Enhancement: Default
.head 5 -  Text Color: Default
.head 5 -  Background Color: Default
.head 4 +  Message Actions
.head 5 +  On SAM_Create
.head 6 -  Set mlsData = 'You can use the EM_SETSEL message to set the starting and ending position of the selection in an edit control.  Selected text
 will be replaced if the user hits any key other than one that positions the cursor like home, end or an arrow key.  You can also use this function to position the cursor at a certain place within the field'
.head 5 +  On SAM_SetFocus
.head 6 -  ! By Default SQLWindows selects text in an edit control when it receives focus.
You can prevent that by calling the SelectText function with 0 for starting and 
ending parameters
.head 6 +  If SalIsValidInteger( dfnStart ) AND SalIsValidInteger( dfnEnd )
.head 7 -  Call SelectText( mlsData, dfnStart, dfnEnd )
.head 3 -  Background Text: Selected Text:
.head 4 -  Resource Id: 53058
.head 4 -  Class Child Ref Key: 0
.head 4 -  Class ChildKey: 0
.head 4 -  Class:
.head 4 -  Window Location and Size
.head 5 -  Left: 0.25"
.head 5 -  Top:    2.548"
.head 5 -  Width:  2.633"
.head 5 -  Width Editable? Yes
.head 5 -  Height: 0.167"
.head 5 -  Height Editable? Yes
.head 4 -  Visible? Yes
.head 4 -  Justify: Left
.head 4 -  Font Name: Default
.head 4 -  Font Size: Default
.head 4 -  Font Enhancement: Default
.head 4 -  Text Color: Default
.head 4 -  Background Color: Default
.head 3 +  Multiline Field: mlsSelectedText
.head 4 -  Class Child Ref Key: 0
.head 4 -  Class ChildKey: 0
.head 4 -  Class:
.head 4 -  Property Template:
.head 4 -  Class DLL Name:
.head 4 -  Data
.head 5 -  Maximum Data Length: Default
.head 5 -  String Type: String
.head 5 -  Editable? No
.head 4 -  Display Settings
.head 5 -  Border? Yes
.head 5 -  Word Wrap? Yes
.head 5 -  Vertical Scroll? Yes
.head 5 -  Window Location and Size
.head 6 -  Left: 0.05"
.head 6 -  Top:    2.738"
.head 6 -  Width:  3.9"
.head 6 -  Width Editable? Yes
.head 6 -  Height: 0.857"
.head 6 -  Height Editable? Yes
.head 5 -  Visible? Yes
.head 5 -  Font Name: Default
.head 5 -  Font Size: Default
.head 5 -  Font Enhancement: Default
.head 5 -  Text Color: Default
.head 5 -  Background Color: Default
.head 4 +  Message Actions
.head 5 +  On SAM_Create
.head 6 -  Set mlsData = 'You can use the EM_SETSEL message to set the starting and ending position of the selection in an edit control.  Selected text
 will be replaced if the user hits any key other than one that positions the cursor like home, end or an arrow key.  You can also use this function to position the cursor at a certain place within the field'
.head 5 +  On SAM_SetFocus
.head 6 -  ! By Default SQLWindows selects text in an edit control when it receives focus.
You can prevent that by calling the SelectText function with 0 for starting and 
ending parameters
.head 6 +  If SalIsValidInteger( dfnStart ) AND SalIsValidInteger( dfnEnd )
.head 7 -  Call SelectText( mlsData, dfnStart, dfnEnd )
.head 2 +  Functions
.head 3 +  Function: MakeLParam
.head 4 -  Description: Takes two numbers and puts them into the high and low order words of lParam
.head 4 +  Returns
.head 5 -  Number:
.head 4 +  Parameters
.head 5 -  Number: nLow
.head 5 -  Number: nHigh
.head 4 -  Static Variables
.head 4 -  Local variables
.head 4 +  Actions
.head 5 -  ! Since SQLWindows currently does not have a SHL operator, by multplying by 65536 we can
shift the high word 16 bits to the right.
.head 5 -  Return nHigh * 65536 | nLow
.head 3 +  Function: GetSelectedText
.head 4 -  Description: Gets selected text in the field by sending the EM_GETSEL message, catching
the return from the SalSendMsg() call and pulling start/end low/high word
values from that.
.head 4 -  Returns
.head 4 +  Parameters
.head 5 -  Window Handle: hWndData
.head 5 -  Receive Number: nStart
.head 5 -  Receive Number: nEnd
.head 5 -  Receive String: sSelectedText
.head 4 -  Static Variables
.head 4 +  Local variables
.head 5 -  Number: nSelected
.head 4 +  Actions
.head 5 -  Call SalSetFocus( hWndData )
.head 5 -  Set nSelected = SalSendMsg( hWndData, EM_GETSEL, 0, 0 )
.head 5 -  Set nStart = SalNumberLow( nSelected )
.head 5 -  Set nEnd = SalNumberHigh( nSelected )
.head 5 -  !
.head 5 -  Set sSelectedText = SalStrMidX( mlsData, nStart, nEnd - nStart )
.head 3 +  Function: SelectText
.head 4 -  Description: Selects text in the field by sending the EM_SETSEL message.
To select all text in a field use
	nStart = 0
	nEnd = -1

To clear the selection use
	nStart = -1
	nEnd = 0

To Place the cursor at the end of the field,  specify a starting position that is greater 
than the length of the string.

To position the cursor at any given place in the field, send a starting and ending position 
that are the position that you want the cursor to be placed at.

Note:  This function will work only on the field that currently has focus, if you try to send
this message to another field it will have no effect.
.head 4 -  Returns
.head 4 +  Parameters
.head 5 -  Window Handle: hWnd
.head 5 -  Number: nStart
.head 5 -  Number: nEnd
.head 4 -  Static Variables
.head 4 -  Local variables
.head 4 +  Actions
.head 5 -  Call SalSetFocus( hWnd )
.head 5 -  Call SalSendMsg( hWnd, EM_SETSEL, 0, MakeLParam( nStart, nEnd ))
.head 2 -  Window Parameters
.head 2 -  Window Variables
.head 2 -  Message Actions
